#define ShiftRegisterPWM_CUSTOM_INTERRUPT

//install these libraries from Sketch -> Include Library -> Manage libraries...

//ShiftRegisterPWM library https://timodenk.com/blog/shiftregister-pwm-library/
#include <ShiftRegisterPWM.h>

//Freqmeasure library https://www.pjrc.com/teensy/td_libs_FreqMeasure.html
#include <FreqMeasure.h>

//EEPROMex library https://playground.arduino.cc/Code/EEPROMex/
#include <EEPROMex.h>
#include <EEPROMVar.h>

//Fast digital read/write functions http://masteringarduino.blogspot.com/2013/10/fastest-and-smallest-digitalread-and.html
#define portOfPin(P)\
  (((P)>=0&&(P)<8)?&PORTD:(((P)>7&&(P)<14)?&PORTB:&PORTC))
#define ddrOfPin(P)\
  (((P)>=0&&(P)<8)?&DDRD:(((P)>7&&(P)<14)?&DDRB:&DDRC))
#define pinOfPin(P)\
  (((P)>=0&&(P)<8)?&PIND:(((P)>7&&(P)<14)?&PINB:&PINC))
#define pinIndex(P)((uint8_t)(P>13?P-14:P&7))
#define pinMask(P)((uint8_t)(1<<pinIndex(P)))

#define pinAsInput(P) *(ddrOfPin(P))&=~pinMask(P)
#define pinAsInputPullUp(P) *(ddrOfPin(P))&=~pinMask(P);digitalHigh(P)
#define pinAsOutput(P) *(ddrOfPin(P))|=pinMask(P)
#define digitalLow(P) *(portOfPin(P))&=~pinMask(P)
#define digitalHigh(P) *(portOfPin(P))|=pinMask(P)
#define isHigh(P)((*(pinOfPin(P))& pinMask(P))>0)
#define isLow(P)((*(pinOfPin(P))& pinMask(P))==0)
#define digitalState(P)((uint8_t)isHigh(P))

ShiftRegisterPWM sr(2, 16);

long frequency;   //storing frequency

long scale[2][96] {
  //432
  { 803, 851, 901, 955, 1012, 1072, 1135, 1203, 1274, 1350, 1431, 1516,
    1628, 1725, 1827, 1936, 2051, 2173, 2302, 2439, 2584, 2738, 2900, 3073,
    3255, 3449, 3654, 3871, 4102, 4346, 4604, 4878, 5168, 5475, 5801, 6145,
    6511, 6898, 7308, 7743, 8203, 8691, 9208, 9755, 10335, 10950, 11601, 12291,
    13022, 13796, 14616, 15486, 16406, 17382, 18416, 19511, 20671, 21900, 23202, 24582,
    26044, 27592, 29233, 30971, 32813, 34764, 36831, 39021, 41342, 43800, 46404, 49164,
    52087, 55185, 58466, 61943, 65626, 69528, 73663, 78043, 82683, 87600, 92809, 98328,
    104174, 110369, 116932, 123885, 131252, 139056, 147325, 156085, 165367, 175200, 185618, 196655
  },
  
  //440
  { 818, 866, 918, 973, 1030, 1092, 1156, 1225, 1298, 1375, 1457, 1544,
    1635, 1732, 1835, 1945, 2060, 2183, 2312, 2450, 2596, 2750, 2914, 3087,
    3270, 3465, 3671, 3889, 4120, 4365, 4625, 4900, 5191, 5500, 5827, 6174,
    6541, 6930, 7342, 7778, 8241, 8731, 9250, 9800, 10383, 11000, 11654, 12347,
    13081, 13859, 14683, 15556, 16481, 17461, 18500, 19600, 20765, 22000, 23308, 24694,
    26163, 27718, 29366, 31113, 32963, 34923, 36999, 39200, 41530, 44000, 46616, 49388,
    52325, 55437, 58733, 62225, 65925, 69846, 73999, 78399, 83061, 88000, 93233, 98777,
    104650, 110873, 117466, 124451, 131851, 139691, 147998, 156798, 166122, 176000, 186466, 197553
  }
};


int curScale = 1;
int curOctave = 0;
int curOut = 0;
int erLed[3] = {0, 0, 0};
int tolerance = 3;
int index = 0;
long tHighLimit = 0;
long tLowLimit = 0;
long tFreq = 0;
long errorScale = 0;
unsigned long strobeScale = 0;
int curStrobe = 0;
int countNumber = 1;
float intfreq;
bool checkInput = false;
bool lCheckInput = false;
unsigned long currentMillis = 0;
unsigned long previousMillis = 0;
unsigned long spreviousMillis = 0;
unsigned long lowPreviousMillis = 0;
unsigned long lastInput = 0;
bool blinky = 0;
bool state = 0;
bool tunedir = 0;
int curNote = 0;
double sum = 0;
int count = 0;
unsigned int inLevel[100];
int levelcount = 0;
bool lowLevel = true;
bool noSignal = true;
int curLowLed1 = 6;
int curLowLed2 = 5;
int mode = 0;
int page = 0;
bool menu = 0;
bool octave = false;
float neardiff;
unsigned long buttonTimer = 0;
bool menuActive = false;
bool scaleActive = false;
bool outActive = false;
bool buttonActive = false;
bool vuActive = false;
unsigned long menuTime = 1000;
unsigned long outTime = 2000;
unsigned long scaleTime = 3000;
unsigned long vuTime = 4000;
bool dPressTimer = false;
bool dPressSave = false;
unsigned long dPressTime = 0;
float curScreenSaver = 1.0;
bool screenSaver = false;
unsigned long screenPreviousMillis = 0;
unsigned long screenBlinkPreviousMillis = 0;
int animPhase = 0;
int animValue = 0;
int animBrightness = 50;
int signalInput = 0;
int curSignal = 0;
int readError = 0;
bool initT = true;
int VUlvl = 0;
int VUmax = 0;
int VUmin = 0;
unsigned long vuLvlTime = 0;
unsigned long vuDownTime = 0;
bool vuDown = false;
unsigned long vuLvlTimePos = 0;
unsigned long vuDownTimePos = 0;
bool vuDownPos = false;
unsigned long vuLvlTimeNeg = 0;
unsigned long vuDownTimeNeg = 0;
bool vuDownNeg = false;
bool vuMode = false;
int VUlvlPos = 0;
int VUlvlNeg = 0;
int lvlBufferSize = 50;


//EEPROM SAVE SETUP
int address = 0;
struct saveTUNE {
  int smode;
  int sout;
  int scurscale;
  bool sinit;
};
saveTUNE saveTUNEInput;
saveTUNE saveTUNEOutput;


void setup() {
  pinMode(2, OUTPUT); // sr data pin
  pinMode(3, OUTPUT); // sr clock pin
  pinMode(4, OUTPUT); // sr latch pin
  pinMode(5, OUTPUT); // sr OE pin
  pinMode(6, OUTPUT); // output select pin
  pinMode(8, INPUT);  // input pin
  pinMode(7, INPUT_PULLUP); // button
  Serial.begin(57600);
  FreqMeasure.begin();


  cli();

  // timer2
  TCCR2A = 0; // set TCCR2A register to 0
  TCCR2B = 0; // set TCCR2B register to 0
  TCNT2  = 0; // set counter value to 0

  OCR2A = 38; // set compare match register

  TCCR2B |= (1 << CS22); // Set CS21 bits for 1:256 prescaler

  TCCR2A |= (1 << WGM21); // turn on CTC mode
  TIMSK2 |= (1 << OCIE2A); // enable timer compare interrupt

  sei(); // allow interrupts

  loadState();
  if (initT) {
    initTUNE();
    saveState();
  }

  for (int i = 0; i < 12; i++) {
    sr.set(i, 0);
  }

  if (curOut) {
    digitalHigh(6);
  } else {
    digitalLow(6);
  }

  //enable shift registers
  digitalWrite(5, LOW);
  bootAnim();
}

ISR(TIMER2_COMPA_vect) {
  cli();
  sr.update();
  sei();
}

void loop() {
  currentMillis = millis();
  measure();
  levelDetection();
  displayLED();
  button();
  if (dPressTimer) {
    if (currentMillis >= dPressTime + 300) {
      dPressTimer = false;
    }
  } 
  
  //printinfo();

}
