void measure() {
  if (FreqMeasure.available()) {
    // average several reading together
    sum = sum + FreqMeasure.read();
    count = count + 1;
    if (count > countNumber) {
      float initfrequency = FreqMeasure.countToFrequency(sum / count);
      frequency = (initfrequency * 100) * 2;

      //average more readings at higher frequencies
      countNumber = map(frequency, 818, 197553, 5, 20);

      //adjust reading error
      readError = map(frequency, 818, 197553, 1, 47);
      frequency = frequency + readError;
      sum = 0;
      count = 0;
    }
  }

  //find nearest note from array
  index = 0;
  neardiff = abs(scale[curScale][0] - frequency);

  for (int i = 1; i < 96; i++) {
    if (abs(scale[curScale][i] - frequency) < neardiff) {
      index = i;
      neardiff = abs(scale[curScale][i] - frequency);
    }
  }

  //set tolerances for the currently found note (+/- 3cent)
  if (index != 96) {
    tHighLimit = scale[curScale][index] + ((abs(scale[curScale][index] - scale[curScale][index + 1]) / 100) * tolerance) + 1;
  } else {
    tHighLimit = scale[curScale][index] + (((scale[curScale][index] - scale[curScale][index - 1]) / 100) * tolerance) + 1;
  }
  if (index != 0) {
    tLowLimit = scale[curScale][index] - (((scale[curScale][index] - scale[curScale][index - 1]) / 100) * tolerance) - 1;
  } else {
    tLowLimit = scale[curScale][index] - ((abs(scale[curScale][index] - scale[curScale][index + 1]) / 100) * tolerance) - 1;
  }

  //if frequency is in tune
  if (frequency <= tHighLimit && frequency >= tLowLimit) {
    state = 1;
  } else {
    state = 0;
  }

  //see if current input is higher or lower than the nearest frequency
  if (frequency > scale[curScale][index]) {
    tunedir = 1;
  } else {
    tunedir = 0;
  }

  //set the current note to display
  for (int a = 0; a < 12; a++) {
    for (int i = a; i < 110; i = i + 12) {
      if (i == index) {
        curNote = a;
      }
    }
  }

  //set the current octave to display
  for (int i = 0; i < 12; i++) {
    if (index >= (i * 12) && index <= (((i + 1) * 12) - 1)) {
      curOctave = i;
    }
  }
}

void levelDetection() {
  signalInput = map(analogRead(A0), 1024, 0, 0, 1024);
  VUlvl = signalInput;
  inLevel[levelcount] = signalInput;
  levelcount = levelcount + 1;
  //check direct input level
  if (levelcount > lvlBufferSize) {
    unsigned int maxlvl = inLevel[0];
    unsigned int minlvl = inLevel[0];
    unsigned int averagelvl = 0;
    for (int i = 0; i < lvlBufferSize; i++) {
      if (inLevel[i] > maxlvl) {
        maxlvl = inLevel[i];
      }
      if (inLevel[i] < minlvl) {
        minlvl = inLevel[i];
      }
      averagelvl = averagelvl + inLevel[i];
    }

    averagelvl = averagelvl / lvlBufferSize;

    if (maxlvl-minlvl<4) {
      noSignal = true;
    } else {
      noSignal = false;
    }
    levelcount = 0;

  }

  //check if there is signal on the sub input
  checkInput = digitalState(8);
  if (checkInput != lCheckInput) {
    lastInput = currentMillis;
    lCheckInput = checkInput;
  }
  if (currentMillis - lastInput > 200) {
    lowLevel = true;
  } else {
    lowLevel = false;
  }

}
